//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      Sample/HardParticle/EllipsoidalSegment.h
//! @brief     Defines class EllipsoidalSegment.
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_SAMPLE_HARDPARTICLE_ELLIPSOIDALSEGMENT_H
#define BORNAGAIN_SAMPLE_HARDPARTICLE_ELLIPSOIDALSEGMENT_H

#include "Sample/Particle/HardFormfactor.h"

//! An hemi ellipsoid,
//!   obtained by truncating a full ellipsoid in the middle plane spanned by two principal axes.

class EllipsoidalSegment : public HardFormfactor {
public:
    EllipsoidalSegment(double radius_x, double radius_y, double radius_z, double rm_top,
                       double rm_bottom);
    ~EllipsoidalSegment() override = default;

    complex_t formfactorAtBottom(C3 q) const override;

    std::string className() const final { return "EllipsoidalSegment"; }

#ifndef SWIG
    EllipsoidalSegment* clone() const override
    {
        return new EllipsoidalSegment(m_radius_x, m_radius_y, m_radius_z, m_rm_top, m_rm_bottom);
    }
    void validate() const override;

    double radiusX() const { return m_radius_x; }
    double radiusY() const { return m_radius_y; }
    double radiusZ() const { return m_radius_z; }
    double cutFromTop() const { return m_rm_top; }
    double cutFromBottom() const { return m_rm_bottom; }

    double radialExtension() const override;
    bool contains(const R3& position) const override;

private:
    double m_radius_x;
    double m_radius_y;
    double m_radius_z;
    double m_rm_top;    //!< height of removed top cap
    double m_rm_bottom; //!< height of removed bottom cap
#endif                  // SWIG
};

#endif // BORNAGAIN_SAMPLE_HARDPARTICLE_ELLIPSOIDALSEGMENT_H
